# Carrier endpoints

## The Carrier object

```json
{"openapi":"3.0.1","info":{"title":"fulfillmenttools","version":"VERSIONLESS"},"components":{"schemas":{"Carrier":{"additionalProperties":false,"allOf":[{"$ref":"#/components/schemas/CarrierForCreation"},{"$ref":"#/components/schemas/VersionedResource"},{"properties":{"defaultParcelHeightInCm":{"default":10,"description":"Default height in cm","minimum":1,"type":"number"},"defaultParcelLengthInCm":{"default":25,"description":"Default length in cm","minimum":1,"type":"number"},"defaultParcelWidthInCm":{"default":35,"description":"Default width in cm","minimum":1,"type":"number"},"deliveryType":{"$ref":"#/components/schemas/CarrierDeliveryType"},"id":{"description":"The id of the carrier","type":"string"},"lifecycle":{"$ref":"#/components/schemas/CarrierLifecycle"},"parcelLabelClassifications":{"items":{"$ref":"#/components/schemas/ParcelLabelClassification"},"type":"array"}},"required":["id","status","defaultParcelWidthInCm","defaultParcelLengthInCm","defaultParcelHeightInCm"],"type":"object"}],"xml":{"name":"Carrier"},"title":"Carrier","description":"Carrier"},"CarrierForCreation":{"additionalProperties":false,"properties":{"credentials":{"$ref":"#/components/schemas/AbstractCarrierCredentials"},"defaultParcelHeightInCm":{"default":10,"description":"Default height in cm","minimum":1,"type":"number"},"defaultParcelLengthInCm":{"default":25,"description":"Default length in cm","minimum":1,"type":"number"},"defaultParcelWeightInGram":{"default":1000,"description":"Default weight for a parcel in gram","minimum":1,"type":"number"},"defaultParcelWidthInCm":{"default":35,"description":"Default width in cm","minimum":1,"type":"number"},"key":{"description":"References the KEP. Currently allowed values are DHL_V2, DPD_CH, DPD_CH_VCE, ANGEL, GLS, FEDEX, POSTNL, BRING, UPS, POST_NORD, DHL_EXPRESS,\n CUSTOM and to distinct between multiple custom carriers one can use CUSTOM_ combined with a unique name.","type":"string"},"logoUrl":{"minLength":1,"type":"string"},"name":{"description":"This is the well known name for a supported CEP partner. Can be adapted to the clients needs.","type":"string"},"parcelLabelClassifications":{"items":{"$ref":"#/components/schemas/ParcelLabelClassificationForCreation"},"type":"array"},"productValueNeeded":{"description":"Setting to enable the Client to ask for the parcel product value while ordering a label. This information is mandatory for sending parcels between different countries (customs declaration)","type":"boolean"},"status":{"$ref":"#/components/schemas/CarrierStatus"}},"required":["name","key"],"type":"object","xml":{"name":"CarrierForCreation"},"title":"CarrierForCreation","description":"CarrierForCreation"},"AbstractCarrierCredentials":{"discriminator":{"propertyName":"key"},"properties":{"key":{"type":"string"}},"required":["key"],"type":"object","xml":{"name":"AbstractCarrierCredentials"},"title":"AbstractCarrierCredentials","description":"AbstractCarrierCredentials"},"ParcelLabelClassificationForCreation":{"additionalProperties":false,"properties":{"nameLocalized":{"$ref":"#/components/schemas/LocaleString","description":"Localized name for parcel label classification"},"dimensions":{"$ref":"#/components/schemas/ParcelDimensions"},"services":{"$ref":"#/components/schemas/ParcelLabelClassificationServices"}},"required":["nameLocalized","dimensions"],"type":"object","title":"ParcelLabelClassificationForCreation","description":"ParcelLabelClassificationForCreation"},"LocaleString":{"additionalProperties":{"type":"string"},"description":"Provides Localized values. The key is the locale, the value is the translation. https://docs.fulfillmenttools.com/documentation/developer-docs/api/core-concepts/localization","title":"LocaleString","type":"object"},"ParcelDimensions":{"additionalProperties":false,"nullable":true,"properties":{"customWeight":{"description":"Set this value if you want to overwrite the calculated weight of the parcel (in g).","type":"number"},"height":{"description":"The height of the package (in cm)","type":"number"},"length":{"description":"The length of the package (in cm)","type":"number"},"weight":{"description":"The weight of the package (in g)","type":"number"},"width":{"description":"The width of the package (in cm)","type":"number"}},"type":"object","title":"ParcelDimensions","description":"ParcelDimensions"},"ParcelLabelClassificationServices":{"additionalProperties":false,"properties":{"bulkyGoods":{"default":false,"type":"boolean"}},"type":"object","title":"ParcelLabelClassificationServices","description":"ParcelLabelClassificationServices"},"CarrierStatus":{"description":"It is taken into consideration for all carriers. Default: INACTIVE","enum":["ACTIVE","INACTIVE"],"type":"string","title":"CarrierStatus"},"VersionedResource":{"properties":{"created":{"description":"The date this entity was created at the platform. This value is generated by the service.","format":"date-time","type":"string"},"lastModified":{"description":"The date this entity was modified last. This value is generated by the service.","format":"date-time","type":"string"},"version":{"description":"The version of the document to be used in optimistic locking mechanisms.","format":"int64","type":"integer"}},"required":["version"],"type":"object","title":"VersionedResource","description":"VersionedResource"},"CarrierDeliveryType":{"description":"Provided delivery of this CEP. Default: DELIVERY","enum":["SAMEDAY","DELIVERY"],"type":"string","title":"CarrierDeliveryType"},"CarrierLifecycle":{"description":"Used to determine if a carrier is available for configuration. GA carriers are generally available and are covered by our SLA. BETA carriers are available, but subject to change and not covered by SLA. ALPHA carriers are not implemented completely, yet. Default: GA","enum":["GA","BETA","ALPHA"],"type":"string","title":"CarrierLifecycle"},"ParcelLabelClassification":{"additionalProperties":false,"properties":{"nameLocalized":{"$ref":"#/components/schemas/LocaleString","description":"Localized name for parcel label classification"},"dimensions":{"$ref":"#/components/schemas/ParcelDimensions"},"name":{"description":"Name of the parcel label classification","type":"string"},"services":{"$ref":"#/components/schemas/ParcelLabelClassificationServices"}},"required":["nameLocalized","dimensions"],"type":"object","title":"ParcelLabelClassification","description":"ParcelLabelClassification"}}}}
```

## GET /api/carriers

> List carriers

```json
{"openapi":"3.0.1","info":{"title":"fulfillmenttools","version":"VERSIONLESS"},"tags":[{"description":"Endpoints to create, update and read carriers.","name":"Carriers (Operations)"}],"servers":[{"url":"https://{tenant}.api.fulfillmenttools.com","variables":{"tenant":{"default":"your-tenant-name"}}}],"security":[{"BearerToken":[]}],"components":{"securitySchemes":{"BearerToken":{"type":"http","scheme":"bearer","bearerFormat":"JWT"}},"schemas":{"StrippedCarriers":{"properties":{"carriers":{"items":{"$ref":"#/components/schemas/StrippedCarrier"},"type":"array"},"total":{"description":"Total number of found entities for this query","type":"integer"}},"type":"object","title":"StrippedCarriers","description":"StrippedCarriers"},"StrippedCarrier":{"allOf":[{"$ref":"#/components/schemas/VersionedResource"},{"properties":{"deliveryType":{"$ref":"#/components/schemas/CarrierDeliveryType"},"id":{"description":"The id of this carrier. It is generated during creation automatically and suits as the primary identifier of the described carrier.","type":"string"},"key":{"type":"string"},"lifecycle":{"$ref":"#/components/schemas/CarrierLifecycle"},"name":{"description":"This is the well known name for a supported CEP partner. Can be adapted to the clients needs.","type":"string"},"status":{"$ref":"#/components/schemas/CarrierStatus"}},"required":["id","name","key"],"type":"object"}],"xml":{"name":"StrippedCarrier"},"title":"StrippedCarrier","description":"StrippedCarrier"},"VersionedResource":{"properties":{"created":{"description":"The date this entity was created at the platform. This value is generated by the service.","format":"date-time","type":"string"},"lastModified":{"description":"The date this entity was modified last. This value is generated by the service.","format":"date-time","type":"string"},"version":{"description":"The version of the document to be used in optimistic locking mechanisms.","format":"int64","type":"integer"}},"required":["version"],"type":"object","title":"VersionedResource","description":"VersionedResource"},"CarrierDeliveryType":{"description":"Provided delivery of this CEP. Default: DELIVERY","enum":["SAMEDAY","DELIVERY"],"type":"string","title":"CarrierDeliveryType"},"CarrierLifecycle":{"description":"Used to determine if a carrier is available for configuration. GA carriers are generally available and are covered by our SLA. BETA carriers are available, but subject to change and not covered by SLA. ALPHA carriers are not implemented completely, yet. Default: GA","enum":["GA","BETA","ALPHA"],"type":"string","title":"CarrierLifecycle"},"CarrierStatus":{"description":"It is taken into consideration for all carriers. Default: INACTIVE","enum":["ACTIVE","INACTIVE"],"type":"string","title":"CarrierStatus"},"ApiError":{"items":{"$ref":"#/components/schemas/ErrorInner"},"type":"array","xml":{"name":"ApiError"},"title":"ApiError","description":"ApiError"},"ErrorInner":{"properties":{"description":{"type":"string"},"requestVersion":{"description":"The version provided within an invalid request.","format":"int64","type":"integer"},"summary":{"type":"string"},"version":{"format":"int64","type":"integer"}},"required":["summary"],"type":"object","title":"ErrorInner","description":"ErrorInner"}}},"paths":{"/api/carriers":{"get":{"description":"","operationId":"getCarriers","parameters":[{"description":"all entities after given Id","in":"query","name":"startAfterId","required":false,"schema":{"type":"string"}},{"description":"number of entities to show","in":"query","name":"size","required":false,"schema":{"default":25,"type":"integer"}},{"description":"Provide the localized names and descriptions for the parcel label classifications. If not provided the default locale is used., for example de_DE.","in":"query","name":"locale","schema":{"type":"string"}}],"responses":{"200":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/StrippedCarriers"}}},"description":"The current list of available carriers"},"401":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"Your user is not allowed to operate against this API instance"},"403":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"Your user, although recognized, is not authorized to use this endpoint"},"404":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"No more elements available"}},"summary":"List carriers","tags":["Carriers (Operations)"]}}}}
```

## GET /api/carriers/{carrierId}

> Get carrier

```json
{"openapi":"3.0.1","info":{"title":"fulfillmenttools","version":"VERSIONLESS"},"tags":[{"description":"Endpoints to create, update and read carriers.","name":"Carriers (Operations)"}],"servers":[{"url":"https://{tenant}.api.fulfillmenttools.com","variables":{"tenant":{"default":"your-tenant-name"}}}],"security":[{"BearerToken":[]}],"components":{"securitySchemes":{"BearerToken":{"type":"http","scheme":"bearer","bearerFormat":"JWT"}},"schemas":{"Carrier":{"additionalProperties":false,"allOf":[{"$ref":"#/components/schemas/CarrierForCreation"},{"$ref":"#/components/schemas/VersionedResource"},{"properties":{"defaultParcelHeightInCm":{"default":10,"description":"Default height in cm","minimum":1,"type":"number"},"defaultParcelLengthInCm":{"default":25,"description":"Default length in cm","minimum":1,"type":"number"},"defaultParcelWidthInCm":{"default":35,"description":"Default width in cm","minimum":1,"type":"number"},"deliveryType":{"$ref":"#/components/schemas/CarrierDeliveryType"},"id":{"description":"The id of the carrier","type":"string"},"lifecycle":{"$ref":"#/components/schemas/CarrierLifecycle"},"parcelLabelClassifications":{"items":{"$ref":"#/components/schemas/ParcelLabelClassification"},"type":"array"}},"required":["id","status","defaultParcelWidthInCm","defaultParcelLengthInCm","defaultParcelHeightInCm"],"type":"object"}],"xml":{"name":"Carrier"},"title":"Carrier","description":"Carrier"},"CarrierForCreation":{"additionalProperties":false,"properties":{"credentials":{"$ref":"#/components/schemas/AbstractCarrierCredentials"},"defaultParcelHeightInCm":{"default":10,"description":"Default height in cm","minimum":1,"type":"number"},"defaultParcelLengthInCm":{"default":25,"description":"Default length in cm","minimum":1,"type":"number"},"defaultParcelWeightInGram":{"default":1000,"description":"Default weight for a parcel in gram","minimum":1,"type":"number"},"defaultParcelWidthInCm":{"default":35,"description":"Default width in cm","minimum":1,"type":"number"},"key":{"description":"References the KEP. Currently allowed values are DHL_V2, DPD_CH, DPD_CH_VCE, ANGEL, GLS, FEDEX, POSTNL, BRING, UPS, POST_NORD, DHL_EXPRESS,\n CUSTOM and to distinct between multiple custom carriers one can use CUSTOM_ combined with a unique name.","type":"string"},"logoUrl":{"minLength":1,"type":"string"},"name":{"description":"This is the well known name for a supported CEP partner. Can be adapted to the clients needs.","type":"string"},"parcelLabelClassifications":{"items":{"$ref":"#/components/schemas/ParcelLabelClassificationForCreation"},"type":"array"},"productValueNeeded":{"description":"Setting to enable the Client to ask for the parcel product value while ordering a label. This information is mandatory for sending parcels between different countries (customs declaration)","type":"boolean"},"status":{"$ref":"#/components/schemas/CarrierStatus"}},"required":["name","key"],"type":"object","xml":{"name":"CarrierForCreation"},"title":"CarrierForCreation","description":"CarrierForCreation"},"AbstractCarrierCredentials":{"discriminator":{"propertyName":"key"},"properties":{"key":{"type":"string"}},"required":["key"],"type":"object","xml":{"name":"AbstractCarrierCredentials"},"title":"AbstractCarrierCredentials","description":"AbstractCarrierCredentials"},"ParcelLabelClassificationForCreation":{"additionalProperties":false,"properties":{"nameLocalized":{"$ref":"#/components/schemas/LocaleString","description":"Localized name for parcel label classification"},"dimensions":{"$ref":"#/components/schemas/ParcelDimensions"},"services":{"$ref":"#/components/schemas/ParcelLabelClassificationServices"}},"required":["nameLocalized","dimensions"],"type":"object","title":"ParcelLabelClassificationForCreation","description":"ParcelLabelClassificationForCreation"},"LocaleString":{"additionalProperties":{"type":"string"},"description":"Provides Localized values. The key is the locale, the value is the translation. https://docs.fulfillmenttools.com/documentation/developer-docs/api/core-concepts/localization","title":"LocaleString","type":"object"},"ParcelDimensions":{"additionalProperties":false,"nullable":true,"properties":{"customWeight":{"description":"Set this value if you want to overwrite the calculated weight of the parcel (in g).","type":"number"},"height":{"description":"The height of the package (in cm)","type":"number"},"length":{"description":"The length of the package (in cm)","type":"number"},"weight":{"description":"The weight of the package (in g)","type":"number"},"width":{"description":"The width of the package (in cm)","type":"number"}},"type":"object","title":"ParcelDimensions","description":"ParcelDimensions"},"ParcelLabelClassificationServices":{"additionalProperties":false,"properties":{"bulkyGoods":{"default":false,"type":"boolean"}},"type":"object","title":"ParcelLabelClassificationServices","description":"ParcelLabelClassificationServices"},"CarrierStatus":{"description":"It is taken into consideration for all carriers. Default: INACTIVE","enum":["ACTIVE","INACTIVE"],"type":"string","title":"CarrierStatus"},"VersionedResource":{"properties":{"created":{"description":"The date this entity was created at the platform. This value is generated by the service.","format":"date-time","type":"string"},"lastModified":{"description":"The date this entity was modified last. This value is generated by the service.","format":"date-time","type":"string"},"version":{"description":"The version of the document to be used in optimistic locking mechanisms.","format":"int64","type":"integer"}},"required":["version"],"type":"object","title":"VersionedResource","description":"VersionedResource"},"CarrierDeliveryType":{"description":"Provided delivery of this CEP. Default: DELIVERY","enum":["SAMEDAY","DELIVERY"],"type":"string","title":"CarrierDeliveryType"},"CarrierLifecycle":{"description":"Used to determine if a carrier is available for configuration. GA carriers are generally available and are covered by our SLA. BETA carriers are available, but subject to change and not covered by SLA. ALPHA carriers are not implemented completely, yet. Default: GA","enum":["GA","BETA","ALPHA"],"type":"string","title":"CarrierLifecycle"},"ParcelLabelClassification":{"additionalProperties":false,"properties":{"nameLocalized":{"$ref":"#/components/schemas/LocaleString","description":"Localized name for parcel label classification"},"dimensions":{"$ref":"#/components/schemas/ParcelDimensions"},"name":{"description":"Name of the parcel label classification","type":"string"},"services":{"$ref":"#/components/schemas/ParcelLabelClassificationServices"}},"required":["nameLocalized","dimensions"],"type":"object","title":"ParcelLabelClassification","description":"ParcelLabelClassification"},"ApiError":{"items":{"$ref":"#/components/schemas/ErrorInner"},"type":"array","xml":{"name":"ApiError"},"title":"ApiError","description":"ApiError"},"ErrorInner":{"properties":{"description":{"type":"string"},"requestVersion":{"description":"The version provided within an invalid request.","format":"int64","type":"integer"},"summary":{"type":"string"},"version":{"format":"int64","type":"integer"}},"required":["summary"],"type":"object","title":"ErrorInner","description":"ErrorInner"}}},"paths":{"/api/carriers/{carrierId}":{"get":{"description":"","operationId":"getCarrier","parameters":[{"description":"ID of the carrier you want to get","in":"path","name":"carrierId","required":true,"schema":{"type":"string"}},{"description":"Provide the localized names and descriptions for the parcel label classifications. If not provided the default locale is used., for example de_DE.","in":"query","name":"locale","schema":{"type":"string"}}],"responses":{"200":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/Carrier"}}},"description":"Carrier was found & you were allowed to access it. The result is in the body."},"401":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"Your user is not allowed to operate against this API instance"},"403":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"Your user, although recognized, is not authorized to use this endpoint"},"404":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"User not found"}},"summary":"Get carrier","tags":["Carriers (Operations)"]}}}}
```

## POST /api/carriers

> Create carrier

```json
{"openapi":"3.0.1","info":{"title":"fulfillmenttools","version":"VERSIONLESS"},"tags":[{"description":"Endpoints to create, update and read carriers.","name":"Carriers (Operations)"}],"servers":[{"url":"https://{tenant}.api.fulfillmenttools.com","variables":{"tenant":{"default":"your-tenant-name"}}}],"security":[{"BearerToken":[]}],"components":{"securitySchemes":{"BearerToken":{"type":"http","scheme":"bearer","bearerFormat":"JWT"}},"schemas":{"CarrierForCreation":{"additionalProperties":false,"properties":{"credentials":{"$ref":"#/components/schemas/AbstractCarrierCredentials"},"defaultParcelHeightInCm":{"default":10,"description":"Default height in cm","minimum":1,"type":"number"},"defaultParcelLengthInCm":{"default":25,"description":"Default length in cm","minimum":1,"type":"number"},"defaultParcelWeightInGram":{"default":1000,"description":"Default weight for a parcel in gram","minimum":1,"type":"number"},"defaultParcelWidthInCm":{"default":35,"description":"Default width in cm","minimum":1,"type":"number"},"key":{"description":"References the KEP. Currently allowed values are DHL_V2, DPD_CH, DPD_CH_VCE, ANGEL, GLS, FEDEX, POSTNL, BRING, UPS, POST_NORD, DHL_EXPRESS,\n CUSTOM and to distinct between multiple custom carriers one can use CUSTOM_ combined with a unique name.","type":"string"},"logoUrl":{"minLength":1,"type":"string"},"name":{"description":"This is the well known name for a supported CEP partner. Can be adapted to the clients needs.","type":"string"},"parcelLabelClassifications":{"items":{"$ref":"#/components/schemas/ParcelLabelClassificationForCreation"},"type":"array"},"productValueNeeded":{"description":"Setting to enable the Client to ask for the parcel product value while ordering a label. This information is mandatory for sending parcels between different countries (customs declaration)","type":"boolean"},"status":{"$ref":"#/components/schemas/CarrierStatus"}},"required":["name","key"],"type":"object","xml":{"name":"CarrierForCreation"},"title":"CarrierForCreation","description":"CarrierForCreation"},"AbstractCarrierCredentials":{"discriminator":{"propertyName":"key"},"properties":{"key":{"type":"string"}},"required":["key"],"type":"object","xml":{"name":"AbstractCarrierCredentials"},"title":"AbstractCarrierCredentials","description":"AbstractCarrierCredentials"},"ParcelLabelClassificationForCreation":{"additionalProperties":false,"properties":{"nameLocalized":{"$ref":"#/components/schemas/LocaleString","description":"Localized name for parcel label classification"},"dimensions":{"$ref":"#/components/schemas/ParcelDimensions"},"services":{"$ref":"#/components/schemas/ParcelLabelClassificationServices"}},"required":["nameLocalized","dimensions"],"type":"object","title":"ParcelLabelClassificationForCreation","description":"ParcelLabelClassificationForCreation"},"LocaleString":{"additionalProperties":{"type":"string"},"description":"Provides Localized values. The key is the locale, the value is the translation. https://docs.fulfillmenttools.com/documentation/developer-docs/api/core-concepts/localization","title":"LocaleString","type":"object"},"ParcelDimensions":{"additionalProperties":false,"nullable":true,"properties":{"customWeight":{"description":"Set this value if you want to overwrite the calculated weight of the parcel (in g).","type":"number"},"height":{"description":"The height of the package (in cm)","type":"number"},"length":{"description":"The length of the package (in cm)","type":"number"},"weight":{"description":"The weight of the package (in g)","type":"number"},"width":{"description":"The width of the package (in cm)","type":"number"}},"type":"object","title":"ParcelDimensions","description":"ParcelDimensions"},"ParcelLabelClassificationServices":{"additionalProperties":false,"properties":{"bulkyGoods":{"default":false,"type":"boolean"}},"type":"object","title":"ParcelLabelClassificationServices","description":"ParcelLabelClassificationServices"},"CarrierStatus":{"description":"It is taken into consideration for all carriers. Default: INACTIVE","enum":["ACTIVE","INACTIVE"],"type":"string","title":"CarrierStatus"},"Carrier":{"additionalProperties":false,"allOf":[{"$ref":"#/components/schemas/CarrierForCreation"},{"$ref":"#/components/schemas/VersionedResource"},{"properties":{"defaultParcelHeightInCm":{"default":10,"description":"Default height in cm","minimum":1,"type":"number"},"defaultParcelLengthInCm":{"default":25,"description":"Default length in cm","minimum":1,"type":"number"},"defaultParcelWidthInCm":{"default":35,"description":"Default width in cm","minimum":1,"type":"number"},"deliveryType":{"$ref":"#/components/schemas/CarrierDeliveryType"},"id":{"description":"The id of the carrier","type":"string"},"lifecycle":{"$ref":"#/components/schemas/CarrierLifecycle"},"parcelLabelClassifications":{"items":{"$ref":"#/components/schemas/ParcelLabelClassification"},"type":"array"}},"required":["id","status","defaultParcelWidthInCm","defaultParcelLengthInCm","defaultParcelHeightInCm"],"type":"object"}],"xml":{"name":"Carrier"},"title":"Carrier","description":"Carrier"},"VersionedResource":{"properties":{"created":{"description":"The date this entity was created at the platform. This value is generated by the service.","format":"date-time","type":"string"},"lastModified":{"description":"The date this entity was modified last. This value is generated by the service.","format":"date-time","type":"string"},"version":{"description":"The version of the document to be used in optimistic locking mechanisms.","format":"int64","type":"integer"}},"required":["version"],"type":"object","title":"VersionedResource","description":"VersionedResource"},"CarrierDeliveryType":{"description":"Provided delivery of this CEP. Default: DELIVERY","enum":["SAMEDAY","DELIVERY"],"type":"string","title":"CarrierDeliveryType"},"CarrierLifecycle":{"description":"Used to determine if a carrier is available for configuration. GA carriers are generally available and are covered by our SLA. BETA carriers are available, but subject to change and not covered by SLA. ALPHA carriers are not implemented completely, yet. Default: GA","enum":["GA","BETA","ALPHA"],"type":"string","title":"CarrierLifecycle"},"ParcelLabelClassification":{"additionalProperties":false,"properties":{"nameLocalized":{"$ref":"#/components/schemas/LocaleString","description":"Localized name for parcel label classification"},"dimensions":{"$ref":"#/components/schemas/ParcelDimensions"},"name":{"description":"Name of the parcel label classification","type":"string"},"services":{"$ref":"#/components/schemas/ParcelLabelClassificationServices"}},"required":["nameLocalized","dimensions"],"type":"object","title":"ParcelLabelClassification","description":"ParcelLabelClassification"},"ApiError":{"items":{"$ref":"#/components/schemas/ErrorInner"},"type":"array","xml":{"name":"ApiError"},"title":"ApiError","description":"ApiError"},"ErrorInner":{"properties":{"description":{"type":"string"},"requestVersion":{"description":"The version provided within an invalid request.","format":"int64","type":"integer"},"summary":{"type":"string"},"version":{"format":"int64","type":"integer"}},"required":["summary"],"type":"object","title":"ErrorInner","description":"ErrorInner"}}},"paths":{"/api/carriers":{"post":{"description":"","operationId":"addCarrier","parameters":[{"description":"Provide the localized names and descriptions for the parcel label classifications. If not provided the default locale is used., for example de_DE.","in":"query","name":"locale","schema":{"type":"string"}}],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/CarrierForCreation"}}},"description":"Carrier object","required":true},"responses":{"201":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/Carrier"}}},"description":"The carrier was successfully created. The Location header contains the URL of the carrier."},"400":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"Invalid input. See response for details"},"401":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"Your user is not allowed to operate against this API instance"},"403":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"Your user, although recognized, is not authorized to use this endpoint"}},"summary":"Create carrier","tags":["Carriers (Operations)"]}}}}
```

## PATCH /api/carriers/{carrierId}

> Update carrier

```json
{"openapi":"3.0.1","info":{"title":"fulfillmenttools","version":"VERSIONLESS"},"tags":[{"description":"Endpoints to create, update and read carriers.","name":"Carriers (Operations)"}],"servers":[{"url":"https://{tenant}.api.fulfillmenttools.com","variables":{"tenant":{"default":"your-tenant-name"}}}],"security":[{"BearerToken":[]}],"components":{"securitySchemes":{"BearerToken":{"type":"http","scheme":"bearer","bearerFormat":"JWT"}},"schemas":{"CarrierPatchActions":{"properties":{"actions":{"items":{"$ref":"#/components/schemas/ModifyCarrier"},"minItems":1,"type":"array"},"version":{"description":"The version of the document to be used in optimistic locking mechanisms.","format":"int64","type":"integer"}},"required":["version","actions"],"type":"object","xml":{"name":"ShipmentPatchActions"},"title":"CarrierPatchActions","description":"CarrierPatchActions"},"ModifyCarrier":{"allOf":[{"$ref":"#/components/schemas/AbstractModificationAction"},{"additionalProperties":false,"properties":{"action":{"description":"Use value 'ModifyCarrierAction', because you want to modify a carrier","enum":["ModifyCarrier"],"type":"string"},"credentials":{"$ref":"#/components/schemas/AbstractModifyCarrierCredentials"},"defaultParcelHeightInCm":{"default":10,"description":"Default height in cm","minimum":1,"type":"number"},"defaultParcelLengthInCm":{"default":25,"description":"Default length in cm","minimum":1,"type":"number"},"defaultParcelWeightInGram":{"default":1000,"description":"Default weight for a parcel in gram","minimum":1,"type":"number"},"defaultParcelWidthInCm":{"default":35,"description":"Default width in cm","minimum":1,"type":"number"},"deliveryType":{"$ref":"#/components/schemas/CarrierDeliveryType"},"lifecycle":{"$ref":"#/components/schemas/CarrierLifecycle"},"logoUrl":{"minLength":1,"type":"string"},"name":{"description":"This is the well known name for a supported CEP partner. Can be adapted to the clients needs.","type":"string"},"parcelLabelClassifications":{"items":{"$ref":"#/components/schemas/ParcelLabelClassificationForCreation"},"type":"array"},"productValueNeeded":{"description":"Setting to enable the Client to ask for the parcel product value while ordering a label. This information is mandatory for sending parcels between different countries (customs declaration)","type":"boolean"},"status":{"$ref":"#/components/schemas/CarrierStatus"}},"required":["action"],"type":"object"}],"xml":{"name":"ModifyCarrier"},"title":"ModifyCarrier","description":"ModifyCarrier"},"AbstractModificationAction":{"discriminator":{"propertyName":"action"},"properties":{"action":{"description":"","enum":["AddAllowedValueToTag","ModifyPickJob","ModifyPickJobLastEditor","RestartPickJob","ResetPickJob","CancelPickRun","CancelHandoverjob","AbortPickJob","FinishPickRun","StartPickRun","ModifyPickLineItem","ModifyPickRunLineItem","ModifyPackJob","PausePackJob","ModifyPackLineItem","SplitLineItemsPackJob","ModifyFacility","ModifyListing","ModifyRetainedOfflineStock","ModifyListingReactivationAfter","ModifyUser","ModifyShipment","ModifyHandoverjob","ModifyCarrier","ModifyShortpick","ModifyRoutingPlan","ModifyFence","ModifyRating","ModifyTimingMode","ModifyGlobalRoutingConfiguration","ModifyOrderSplit","ModifyPrioritization","ModifyLoadUnitType","ModifyFeature","ModifyParcel","ModifyParcelLoadUnit","ModifyRestowItem","RemovePickJobFromPickRun","ModifyPartialStock","AddTagsToProcess","AssignFacilityToProcess","UpdateGdprCleanupDateAction","ModifyStorageLocation","ModifyPackingContainerType","ModifyPackingContainerTypeIcon","ReplaceCodesInPackingTargetContainer","ReplaceLoadUnitLineItems","AddLineItemToPackingTargetContainer","RemoveLineItemFromPackingTargetContainer","UpdateLineItemOnPackingTargetContainer","UpdatePackingTargetContainerLineItemRecordableAttributes","ModifyCustomService","UnlockOrder"],"type":"string"}},"required":["action"],"type":"object","xml":{"name":"AbstractModificationAction"},"title":"AbstractModificationAction","description":"AbstractModificationAction"},"AbstractModifyCarrierCredentials":{"discriminator":{"propertyName":"key"},"properties":{"key":{"type":"string"}},"required":["key"],"type":"object","xml":{"name":"AbstractModifyCarrierCredentials"},"title":"AbstractModifyCarrierCredentials","description":"AbstractModifyCarrierCredentials"},"CarrierDeliveryType":{"description":"Provided delivery of this CEP. Default: DELIVERY","enum":["SAMEDAY","DELIVERY"],"type":"string","title":"CarrierDeliveryType"},"CarrierLifecycle":{"description":"Used to determine if a carrier is available for configuration. GA carriers are generally available and are covered by our SLA. BETA carriers are available, but subject to change and not covered by SLA. ALPHA carriers are not implemented completely, yet. Default: GA","enum":["GA","BETA","ALPHA"],"type":"string","title":"CarrierLifecycle"},"ParcelLabelClassificationForCreation":{"additionalProperties":false,"properties":{"nameLocalized":{"$ref":"#/components/schemas/LocaleString","description":"Localized name for parcel label classification"},"dimensions":{"$ref":"#/components/schemas/ParcelDimensions"},"services":{"$ref":"#/components/schemas/ParcelLabelClassificationServices"}},"required":["nameLocalized","dimensions"],"type":"object","title":"ParcelLabelClassificationForCreation","description":"ParcelLabelClassificationForCreation"},"LocaleString":{"additionalProperties":{"type":"string"},"description":"Provides Localized values. The key is the locale, the value is the translation. https://docs.fulfillmenttools.com/documentation/developer-docs/api/core-concepts/localization","title":"LocaleString","type":"object"},"ParcelDimensions":{"additionalProperties":false,"nullable":true,"properties":{"customWeight":{"description":"Set this value if you want to overwrite the calculated weight of the parcel (in g).","type":"number"},"height":{"description":"The height of the package (in cm)","type":"number"},"length":{"description":"The length of the package (in cm)","type":"number"},"weight":{"description":"The weight of the package (in g)","type":"number"},"width":{"description":"The width of the package (in cm)","type":"number"}},"type":"object","title":"ParcelDimensions","description":"ParcelDimensions"},"ParcelLabelClassificationServices":{"additionalProperties":false,"properties":{"bulkyGoods":{"default":false,"type":"boolean"}},"type":"object","title":"ParcelLabelClassificationServices","description":"ParcelLabelClassificationServices"},"CarrierStatus":{"description":"It is taken into consideration for all carriers. Default: INACTIVE","enum":["ACTIVE","INACTIVE"],"type":"string","title":"CarrierStatus"},"Carrier":{"additionalProperties":false,"allOf":[{"$ref":"#/components/schemas/CarrierForCreation"},{"$ref":"#/components/schemas/VersionedResource"},{"properties":{"defaultParcelHeightInCm":{"default":10,"description":"Default height in cm","minimum":1,"type":"number"},"defaultParcelLengthInCm":{"default":25,"description":"Default length in cm","minimum":1,"type":"number"},"defaultParcelWidthInCm":{"default":35,"description":"Default width in cm","minimum":1,"type":"number"},"deliveryType":{"$ref":"#/components/schemas/CarrierDeliveryType"},"id":{"description":"The id of the carrier","type":"string"},"lifecycle":{"$ref":"#/components/schemas/CarrierLifecycle"},"parcelLabelClassifications":{"items":{"$ref":"#/components/schemas/ParcelLabelClassification"},"type":"array"}},"required":["id","status","defaultParcelWidthInCm","defaultParcelLengthInCm","defaultParcelHeightInCm"],"type":"object"}],"xml":{"name":"Carrier"},"title":"Carrier","description":"Carrier"},"CarrierForCreation":{"additionalProperties":false,"properties":{"credentials":{"$ref":"#/components/schemas/AbstractCarrierCredentials"},"defaultParcelHeightInCm":{"default":10,"description":"Default height in cm","minimum":1,"type":"number"},"defaultParcelLengthInCm":{"default":25,"description":"Default length in cm","minimum":1,"type":"number"},"defaultParcelWeightInGram":{"default":1000,"description":"Default weight for a parcel in gram","minimum":1,"type":"number"},"defaultParcelWidthInCm":{"default":35,"description":"Default width in cm","minimum":1,"type":"number"},"key":{"description":"References the KEP. Currently allowed values are DHL_V2, DPD_CH, DPD_CH_VCE, ANGEL, GLS, FEDEX, POSTNL, BRING, UPS, POST_NORD, DHL_EXPRESS,\n CUSTOM and to distinct between multiple custom carriers one can use CUSTOM_ combined with a unique name.","type":"string"},"logoUrl":{"minLength":1,"type":"string"},"name":{"description":"This is the well known name for a supported CEP partner. Can be adapted to the clients needs.","type":"string"},"parcelLabelClassifications":{"items":{"$ref":"#/components/schemas/ParcelLabelClassificationForCreation"},"type":"array"},"productValueNeeded":{"description":"Setting to enable the Client to ask for the parcel product value while ordering a label. This information is mandatory for sending parcels between different countries (customs declaration)","type":"boolean"},"status":{"$ref":"#/components/schemas/CarrierStatus"}},"required":["name","key"],"type":"object","xml":{"name":"CarrierForCreation"},"title":"CarrierForCreation","description":"CarrierForCreation"},"AbstractCarrierCredentials":{"discriminator":{"propertyName":"key"},"properties":{"key":{"type":"string"}},"required":["key"],"type":"object","xml":{"name":"AbstractCarrierCredentials"},"title":"AbstractCarrierCredentials","description":"AbstractCarrierCredentials"},"VersionedResource":{"properties":{"created":{"description":"The date this entity was created at the platform. This value is generated by the service.","format":"date-time","type":"string"},"lastModified":{"description":"The date this entity was modified last. This value is generated by the service.","format":"date-time","type":"string"},"version":{"description":"The version of the document to be used in optimistic locking mechanisms.","format":"int64","type":"integer"}},"required":["version"],"type":"object","title":"VersionedResource","description":"VersionedResource"},"ParcelLabelClassification":{"additionalProperties":false,"properties":{"nameLocalized":{"$ref":"#/components/schemas/LocaleString","description":"Localized name for parcel label classification"},"dimensions":{"$ref":"#/components/schemas/ParcelDimensions"},"name":{"description":"Name of the parcel label classification","type":"string"},"services":{"$ref":"#/components/schemas/ParcelLabelClassificationServices"}},"required":["nameLocalized","dimensions"],"type":"object","title":"ParcelLabelClassification","description":"ParcelLabelClassification"},"ApiError":{"items":{"$ref":"#/components/schemas/ErrorInner"},"type":"array","xml":{"name":"ApiError"},"title":"ApiError","description":"ApiError"},"ErrorInner":{"properties":{"description":{"type":"string"},"requestVersion":{"description":"The version provided within an invalid request.","format":"int64","type":"integer"},"summary":{"type":"string"},"version":{"format":"int64","type":"integer"}},"required":["summary"],"type":"object","title":"ErrorInner","description":"ErrorInner"}}},"paths":{"/api/carriers/{carrierId}":{"patch":{"description":"","operationId":"patchCarrier","parameters":[{"description":"ID of carrier you want to patch","in":"path","name":"carrierId","required":true,"schema":{"type":"string"}},{"description":"Provide the localized names and descriptions for the parcel label classifications. If not provided the default locale is used., for example de_DE.","in":"query","name":"locale","schema":{"type":"string"}}],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/CarrierPatchActions"}}},"description":"Patch set","required":true},"responses":{"200":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/Carrier"}}},"description":"Carrier was found & patch-set has been applied. The patched entity is in the body."},"401":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"Your user is not allowed to operate against this API instance"},"403":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"Your user, although recognized, is not authorized to use this endpoint"},"404":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"Entity not found"},"409":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"Entity version conflict"}},"summary":"Update carrier","tags":["Carriers (Operations)"]}}}}
```

## GET /api/carriers/{carrierId}/configuration

> Get carrier config

```json
{"openapi":"3.0.1","info":{"title":"fulfillmenttools","version":"VERSIONLESS"},"tags":[{"description":"Endpoints to create, update and read carriers configuration.","name":"Carriers Configuration (Operations)"}],"servers":[{"url":"https://{tenant}.api.fulfillmenttools.com","variables":{"tenant":{"default":"your-tenant-name"}}}],"security":[{"BearerToken":[]}],"components":{"securitySchemes":{"BearerToken":{"type":"http","scheme":"bearer","bearerFormat":"JWT"}},"schemas":{"CarrierConfiguration":{"allOf":[{"$ref":"#/components/schemas/VersionedResource"}],"description":"Configuration of a Carrier","properties":{"additionalWeightInPercent":{"description":"It is an amount of percentage for packaging weight which will be added to the calculated shipping weight","minimum":0,"type":"number"},"alternativeReturnAddress":{"$ref":"#/components/schemas/FacilityAddress"},"alternativeSendAddress":{"$ref":"#/components/schemas/FacilityAddress"},"carrierRef":{"type":"string"},"countryServiceMappings":{"items":{"$ref":"#/components/schemas/CarrierCountryServiceMapping"},"type":"array"},"defaultPickUpTime":{"$ref":"#/components/schemas/CarrierPickUpTime"},"fallBackTrackAndTraceEmail":{"description":"EmailAddress used to receive track and trace information when no other emailaddress was provided","format":"email","minLength":1,"type":"string"},"id":{"type":"string"},"mustBeWeighed":{"default":false,"description":"Indicates if the content of a parcel must be weighed before ordering a label","type":"boolean"},"nonDeliveryDaysPerCountryAndProvince":{"items":{"$ref":"#/components/schemas/NonDeliveryDaysPerCountryAndProvince"},"type":"array"},"returnLabel":{"default":false,"description":"When enabled, a return label will be created by creating a shipping label","type":"boolean"},"serviceUrl":{"type":"string"},"thresholdPriceValue":{"$ref":"#/components/schemas/ThresholdPriceValue"}},"required":["returnLabel","carrierRef"],"title":"CarrierConfiguration","type":"object"},"VersionedResource":{"properties":{"created":{"description":"The date this entity was created at the platform. This value is generated by the service.","format":"date-time","type":"string"},"lastModified":{"description":"The date this entity was modified last. This value is generated by the service.","format":"date-time","type":"string"},"version":{"description":"The version of the document to be used in optimistic locking mechanisms.","format":"int64","type":"integer"}},"required":["version"],"type":"object","title":"VersionedResource","description":"VersionedResource"},"FacilityAddress":{"allOf":[{"$ref":"#/components/schemas/FacilityAddressForCreation"},{"properties":{"resolvedTimeZone":{"$ref":"#/components/schemas/TimeZone"}},"type":"object"}],"type":"object","xml":{"name":"FacilityAddress"},"title":"FacilityAddress","description":"FacilityAddress"},"FacilityAddressForCreation":{"allOf":[{"$ref":"#/components/schemas/Address"},{"properties":{"companyName":{"type":"string"},"emailAddresses":{"items":{"properties":{"recipient":{"description":"Human readable information who is the recipient for emails sent to this address.","type":"string"},"value":{"type":"string"}},"required":["value"],"type":"object"},"type":"array"},"resolvedCoordinates":{"$ref":"#/components/schemas/Coordinates"},"resolvedTimeZone":{"$ref":"#/components/schemas/TimeZoneForCreation","description":"User-specified time zone in identifier format (e.g., \"America/Los_Angeles\"). Used to determine local time. Relevant only if the country spans multiple time zones; otherwise, the time zone is automatically determined from the country or via Google if unspecified."}},"required":["companyName"],"type":"object"}],"type":"object","xml":{"name":"FacilityAddressForCreation"},"title":"FacilityAddressForCreation","description":"FacilityAddressForCreation"},"Address":{"properties":{"additionalAddressInfo":{"type":"string"},"city":{"pattern":"^.+$","type":"string"},"country":{"description":"A two-digit country code as per ISO 3166-1 alpha-2","pattern":"^[A-Z]{2}$","type":"string"},"customAttributes":{"description":"Attributes that can be added to the address. These attributes cannot be used within fulfillment processes, but it could be useful to have the informations carried here.","type":"object"},"houseNumber":{"pattern":"^.+$","type":"string"},"phoneNumbers":{"items":{"properties":{"customAttributes":{"description":"Attributes that can be added to the phonenumber. These attributes cannot be used within fulfillment processes, but it could be useful to have the informations carried here.","type":"object"},"label":{"description":"Can be used to give a description for the number, like \"private\", \"business number\", etc.","type":"string"},"type":{"enum":["MOBILE","PHONE"],"type":"string"},"value":{"description":"The number itself. We do not enforce any format (yet).","type":"string"}},"required":["value","type"],"type":"object"},"type":"array"},"postalCode":{"pattern":"^.+$","type":"string"},"province":{"pattern":"^.+$","type":"string"},"street":{"pattern":"^.+$","type":"string"}},"required":["street","city","postalCode","country"],"type":"object","title":"Address","description":"Address"},"Coordinates":{"description":"Coordinates of the WGS84 geodetic reference system in Mercator projection, as used e.g. by the Google Maps API","properties":{"lat":{"description":"Latitude value","type":"number"},"lon":{"description":"Longitude value","type":"number"}},"required":["lat","lon"],"type":"object","title":"Coordinates"},"TimeZoneForCreation":{"description":"Self-provided timezone for determining the local time of a facility","properties":{"timeZoneId":{"description":"official id of the timezone","type":"string"}},"required":["timeZoneId"],"type":"object","title":"TimeZoneForCreation"},"TimeZone":{"description":"Timezone for information retrieved e.g. by the Google Maps API","properties":{"offsetInSeconds":{"description":"offset in seconds to standard time. Does not account for daylight saving time.","type":"number"},"source":{"description":"source of the timezone information","type":"string"},"timeZoneId":{"description":"official id of the timezone","type":"string"},"timeZoneName":{"description":"descriptive name of the timezone","type":"string"}},"required":["timeZoneId","timeZoneName","offsetInSeconds"],"type":"object","title":"TimeZone"},"CarrierCountryServiceMapping":{"additionalProperties":false,"properties":{"additionalShippingArticleAttributes":{"description":"Article Attributes that will be displayed in the client as additional. They are not mandatory but could benefit the process. Mandatory fields can not be additional. If duplicates found, the additional values will be removed on read.","items":{"$ref":"#/components/schemas/AdditionalShippingArticleAttribute"},"minItems":0,"type":"array"},"additionalShippingAttributes":{"description":"Shipping Attributes that will be displayed in the client as additional. They are not mandatory but could benefit the process. Mandatory fields can not be additional If duplicates found, the additional values will be removed on read.","items":{"$ref":"#/components/schemas/AdditionalShippingAttribute"},"minItems":0,"type":"array"},"carrierProductCategory":{"$ref":"#/components/schemas/CarrierProductCategory"},"carrierServices":{"description":"Services which can be provided by the carrier","items":{"$ref":"#/components/schemas/CarrierServices"},"type":"array"},"countAsTransitDayBefore":{"type":"string"},"deliveryCosts":{"items":{"$ref":"#/components/schemas/DeliveryCost"},"maxItems":1,"type":"array"},"destinationCountries":{"description":"This part of the API is deprecated. For details please check the <a href=\"https://docs.fulfillmenttools.com/documentation/developer-docs/api/core-concepts/api-release-life-cycle#deprecated\" target=\"_blank\">api-release-life-cycle documentation</a>.<br /><br />@deprecated - Use destination instead.","items":{"$ref":"#/components/schemas/CountryCode"},"minItems":1,"type":"array","deprecated":true},"destinations":{"description":"The destination regions this mapping should be applied to.","items":{"$ref":"#/components/schemas/RegionInformation"},"minItems":1,"type":"array"},"id":{"description":"unique identifier for a countryServiceMapping","type":"string"},"mandatoryShippingArticleAttributes":{"items":{"$ref":"#/components/schemas/MandatoryShippingArticleAttribute"},"minItems":0,"type":"array"},"mandatoryShippingAttributes":{"items":{"$ref":"#/components/schemas/MandatoryShippingAttribute"},"minItems":0,"type":"array"},"mandatoryShippingItemAttributes":{"deprecated":true,"description":"Deprecated - use mandatoryShippingArticleAttributes instead","items":{"$ref":"#/components/schemas/MandatoryShippingItemAttribute"},"minItems":0,"type":"array"},"products":{"description":"Array of products for the given mapping","items":{"type":"string"},"type":"array"},"source":{"$ref":"#/components/schemas/RegionInformation"},"sourceCountry":{"description":"This part of the API is deprecated. For details please check the <a href=\"https://docs.fulfillmenttools.com/documentation/developer-docs/api/core-concepts/api-release-life-cycle#deprecated\" target=\"_blank\">api-release-life-cycle documentation</a>.<br /><br />@deprecated - Use source instead.","maxLength":2,"minLength":2,"type":"string","deprecated":true},"staticCCSMRef":{"type":"string"},"transitTime":{"$ref":"#/components/schemas/CarrierTransitTime"}},"required":["id","source","destinations"],"type":"object","title":"CarrierCountryServiceMapping","description":"CarrierCountryServiceMapping"},"AdditionalShippingArticleAttribute":{"allOf":[{"$ref":"#/components/schemas/CountryServiceMappingShippingArticleAttribute"}],"title":"AdditionalShippingArticleAttribute","description":"AdditionalShippingArticleAttribute"},"CountryServiceMappingShippingArticleAttribute":{"additionalProperties":false,"properties":{"descriptionLocalized":{"$ref":"#/components/schemas/LocaleString"},"category":{"$ref":"#/components/schemas/MandatoryShippingArticleAttributeCategory"},"dataType":{"$ref":"#/components/schemas/MandatoryShippingArticleAttributeDataType"},"description":{"type":"string"},"referencedField":{"$ref":"#/components/schemas/MandatoryShippingArticleAttributeReferencedField"}},"required":["referencedField","dataType","category","descriptionLocalized"],"type":"object","title":"CountryServiceMappingShippingArticleAttribute","description":"CountryServiceMappingShippingArticleAttribute"},"LocaleString":{"additionalProperties":{"type":"string"},"description":"Provides Localized values. The key is the locale, the value is the translation. https://docs.fulfillmenttools.com/documentation/developer-docs/api/core-concepts/localization","title":"LocaleString","type":"object"},"MandatoryShippingArticleAttributeCategory":{"enum":["customs","dimensions","insurance"],"type":"string","title":"MandatoryShippingArticleAttributeCategory","description":"MandatoryShippingArticleAttributeCategory"},"MandatoryShippingArticleAttributeDataType":{"enum":["NUMBER","STRING"],"type":"string","title":"MandatoryShippingArticleAttributeDataType","description":"MandatoryShippingArticleAttributeDataType"},"MandatoryShippingArticleAttributeReferencedField":{"enum":["attributes.weightPerUnit","attributes.hsCode","attributes.currency","attributes.valuePerUnit","attributes.countryOfManufacture"],"type":"string","title":"MandatoryShippingArticleAttributeReferencedField","description":"MandatoryShippingArticleAttributeReferencedField"},"AdditionalShippingAttribute":{"allOf":[{"$ref":"#/components/schemas/CountryServiceMappingShippingAttribute"}],"title":"AdditionalShippingAttribute","description":"AdditionalShippingAttribute"},"CountryServiceMappingShippingAttribute":{"additionalProperties":false,"properties":{"descriptionLocalized":{"$ref":"#/components/schemas/LocaleString"},"dataType":{"enum":["Number","String","Date","Boolean"],"type":"string"},"description":{"type":"string"},"referencedField":{"description":"- dimensions.weight: will be calculated from MandatoryShippingArticleAttribute.attributes.weightPerUnit if items with weightPerUnit is set on all items - productValue: will be calculated from MandatoryShippingArticleAttribute.attributes.pricePerUnit if items with pricePerUnit is set on all items","enum":["dimensions.weight","productValue","pickUpInformation.startTime","pickUpInformation.endTime","services.BulkyGoods","services.Signature","services.AdultSignature","services.CustomerSignature","services.SaturdayDelivery","services.IdentityCheckPrivate","services.IdentityCheckCompany","services.AdditionalTransportInsurance","carrierInformation.shippingContainerNumber"],"type":"string"}},"type":"object","title":"CountryServiceMappingShippingAttribute","description":"CountryServiceMappingShippingAttribute"},"CarrierProductCategory":{"description":"Desired product class to choose when ordering a label, this is not a carrier specific value","enum":["STANDARD","EXPRESS","VALUE","FORWARDING"],"type":"string","title":"CarrierProductCategory"},"CarrierServices":{"description":"Services which should be booked from carrier","enum":["SIGNATURE","CUSTOMER_SIGNATURE","ADULT_SIGNATURE","SATURDAY_DELIVERY","IDENTITY_CHECK_COMPANY","IDENTITY_CHECK_PRIVATE","ADDITIONAL_TRANSPORTATION_INSURANCE"],"type":"string","title":"CarrierServices"},"DeliveryCost":{"additionalProperties":false,"properties":{"cost":{"description":"The cost of sending with a carrier","type":"number"},"currency":{"description":"currency as 3 letter iso code","pattern":"^[A-Z]{3}$","type":"string"}},"required":["cost","currency"],"type":"object","title":"DeliveryCost","description":"DeliveryCost"},"CountryCode":{"description":"ISO 3166 ALPHA-2 of country","maxLength":2,"minLength":2,"type":"string","title":"CountryCode"},"RegionInformation":{"properties":{"countryCode":{"$ref":"#/components/schemas/CountryCode"},"postalCodes":{"items":{"type":"string"},"type":"array"}},"required":["countryCode"],"type":"object","title":"RegionInformation","description":"RegionInformation"},"MandatoryShippingArticleAttribute":{"allOf":[{"$ref":"#/components/schemas/CountryServiceMappingShippingArticleAttribute"}],"title":"MandatoryShippingArticleAttribute","description":"MandatoryShippingArticleAttribute"},"MandatoryShippingAttribute":{"allOf":[{"$ref":"#/components/schemas/CountryServiceMappingShippingAttribute"}],"title":"MandatoryShippingAttribute","description":"MandatoryShippingAttribute"},"MandatoryShippingItemAttribute":{"additionalProperties":false,"properties":{"descriptionLocalized":{"$ref":"#/components/schemas/LocaleString"},"dataType":{"enum":["Number","String","Date","Boolean"],"type":"string"},"description":{"type":"string"},"referencedField":{"description":"Deprecated:\n  - description: article.title will be used instead\n  - weightInGram: use MandatoryShippingArticleAttribute.attributes.weightPerUnit\n  - quantity, this field is now mandatory in the item\n  - parcelItemValue.value: use MandatoryShippingArticleAttribute.attributes.pricePerUnit\n  - parcelItemValue.currency: use MandatoryShippingArticleAttribute.attributes.currency\n  - countryOfManufacture: use MandatoryShippingArticleAttribute.attributes.countryOfManufacture\n  - tenantArticleId: mandatory on line item article","enum":["description","weightInGram","quantity","parcelItemValue.value","parcelItemValue.currency","countryOfManufacture","tenantArticleId"],"type":"string"}},"type":"object","title":"MandatoryShippingItemAttribute","description":"MandatoryShippingItemAttribute"},"CarrierTransitTime":{"properties":{"maxTransitDays":{"description":"Maximum days a carrier needs for transit","minimum":0,"type":"integer"},"minTransitDays":{"description":"Minimum days a carrier needs for transit","minimum":0,"type":"integer"}},"required":["maxTransitDays","minTransitDays"],"type":"object","title":"CarrierTransitTime","description":"CarrierTransitTime"},"CarrierPickUpTime":{"additionalProperties":false,"description":"Default pick up time configuration for carriers supporting pick up scheduling, will be used to calculate the next possible pick up date","properties":{"end":{"$ref":"#/components/schemas/TimeStamp"},"start":{"$ref":"#/components/schemas/TimeStamp"}},"required":["start","end"],"title":"CarrierPickUpTime"},"TimeStamp":{"properties":{"hour":{"maximum":23,"minimum":0,"type":"number"},"minute":{"maximum":59,"minimum":0,"type":"number"}},"required":["hour","minute"],"type":"object","title":"TimeStamp","description":"TimeStamp"},"NonDeliveryDaysPerCountryAndProvince":{"additionalProperties":false,"properties":{"country":{"type":"string"},"nonDeliveryDays":{"items":{"$ref":"#/components/schemas/NonDeliveryDays"},"type":"array"},"nonDeliveryDaysPerProvince":{"items":{"$ref":"#/components/schemas/NonDeliveryDaysPerProvince"},"type":"array"},"recurringNonDeliveryWeekdays":{"items":{"$ref":"#/components/schemas/WeekDay"},"type":"array"}},"required":["country","nonDeliveryDays","recurringNonDeliveryWeekdays","nonDeliveryDaysPerProvince"],"type":"object","title":"NonDeliveryDaysPerCountryAndProvince","description":"NonDeliveryDaysPerCountryAndProvince"},"NonDeliveryDays":{"additionalProperties":false,"properties":{"nonDeliveryDay":{"format":"date","pattern":"^\\d{4}-\\d{2}-\\d{2}$","type":"string"},"nonDeliveryType":{"$ref":"#/components/schemas/NonDeliveryType","default":"SINGLE"}},"required":["nonDeliveryDay"],"type":"object","title":"NonDeliveryDays","description":"NonDeliveryDays"},"NonDeliveryType":{"enum":["SINGLE","RECURRING"],"type":"string","title":"NonDeliveryType","description":"NonDeliveryType"},"NonDeliveryDaysPerProvince":{"additionalProperties":false,"properties":{"nonDeliveryDays":{"items":{"$ref":"#/components/schemas/NonDeliveryDays"},"type":"array"},"province":{"type":"string"},"recurringNonDeliveryWeekdays":{"items":{"$ref":"#/components/schemas/WeekDay"},"type":"array"}},"required":["province","nonDeliveryDays","recurringNonDeliveryWeekdays"],"type":"object","title":"NonDeliveryDaysPerProvince","description":"NonDeliveryDaysPerProvince"},"WeekDay":{"description":"A weekday","enum":["MONDAY","TUESDAY","WEDNESDAY","THURSDAY","FRIDAY","SATURDAY","SUNDAY"],"type":"string","xml":{"name":"WeekDay"},"title":"WeekDay"},"ThresholdPriceValue":{"additionalProperties":false,"properties":{"priceRange":{"$ref":"#/components/schemas/PriceRange"},"priority":{"description":"The lower the value the higher is the priority, e.g. priority 1 is higher than priority 10. The priority is used when comparing multiple carriers.","minimum":1,"type":"integer"}},"required":["priority","priceRange"],"type":"object","title":"ThresholdPriceValue","description":"ThresholdPriceValue"},"PriceRange":{"additionalProperties":false,"properties":{"currency":{"allOf":[{"$ref":"#/components/schemas/CurrencyCode"}],"description":"The currency of the price as an ISO 4217 code.","nullable":true,"type":"string"},"decimalPlaces":{"description":"Number of decimal places for the given currency","minimum":0,"type":"integer"},"from":{"description":"Lowest total parcel value that this carrier will be selected for. Value is in configured in the smallest subunit, e.g. cents.","minimum":0,"type":"integer"},"to":{"description":"Highest total parcel value that this carrier will be selected for. Value is configured in the smallest subunit, e.g. cents.","minimum":1,"type":"integer"}},"required":["from","to","currency","decimalPlaces"],"type":"object","title":"PriceRange","description":"PriceRange"},"CurrencyCode":{"description":"The currency code is a three-letter code that represents a currency in the ISO 4217 standard.","enum":["AED","AFN","ALL","AMD","ANG","AOA","ARS","AUD","AWG","AZN","BAM","BBD","BDT","BGN","BHD","BIF","BMD","BND","BOB","BOV","BRL","BSD","BTN","BWP","BYN","BZD","CAD","CDF","CHE","CHF","CHW","CLF","CLP","CNY","COP","COU","CRC","CUC","CUP","CVE","CZK","DJF","DKK","DOP","DZD","EGP","ERN","ETB","EUR","FJD","FKP","GBP","GEL","GHS","GIP","GMD","GNF","GTQ","GYD","HKD","HNL","HTG","HUF","IDR","ILS","INR","IQD","IRR","ISK","JMD","JOD","JPY","KES","KGS","KHR","KMF","KPW","KRW","KWD","KYD","KZT","LAK","LBP","LKR","LRD","LSL","LYD","MAD","MDL","MGA","MKD","MMK","MNT","MOP","MRU","MUR","MVR","MWK","MXN","MXV","MYR","MZN","NAD","NGN","NIO","NOK","NPR","NZD","OMR","PAB","PEN","PGK","PHP","PKR","PLN","PYG","QAR","RON","RSD","RUB","RWF","SAR","SBD","SCR","SDG","SEK","SGD","SHP","SLE","SOS","SRD","SSP","STN","SVC","SYP","SZL","THB","TJS","TMT","TND","TOP","TRY","TTD","TWD","TZS","UAH","UGX","USD","USN","UYI","UYU","UYW","UZS","VED","VES","VND","VUV","WST","XAF","XAG","XAU","XBA","XBB","XBC","XBD","XCD","XDR","XOF","XPD","XPF","XPT","XSU","XTS","XUA","XXX","YER","ZAR","ZMW","ZWL"],"type":"string","title":"CurrencyCode"},"GlsCarrierConfiguration":{"allOf":[{"$ref":"#/components/schemas/CarrierConfiguration"}],"description":"Configuration of GLS Carrier","properties":{"alternativeReturnAddressLocationId":{"minLength":1,"type":"string"},"alternativeSendAddressLocationId":{"minLength":1,"type":"string"},"trackAndTraceUrl":{"type":"string"},"trackAndTraceWsdlUrl":{"type":"string"}},"title":"GlsCarrierConfiguration"},"FedexCarrierConfiguration":{"allOf":[{"$ref":"#/components/schemas/CarrierConfiguration"}],"description":"Configuration of Fedex Carrier","properties":{"defaultCommodityDescription":{"description":"Describes the shipped goods","type":"string"},"defaultManufactureCountry":{"description":"A two-digit country code as per ISO 3166-1 alpha-2","pattern":"^[A-Z]{2}$","type":"string"},"defaultPriceCurrency":{"description":"default currency of shipped goods as 3 letter iso code","pattern":"^[A-Z]{3}$","type":"string"},"defaultPriceValue":{"description":"Default value of shipped goods","type":"number"},"trackAndTraceUrl":{"type":"string"},"useEconomyService":{"description":"Indicates if the economy services of fedex should be used.","type":"boolean"}},"required":["useEconomyService","defaultPriceCurrency","defaultPriceValue","defaultManufactureCountry","defaultCommodityDescription"],"title":"FedexCarrierConfiguration"},"BringCarrierConfiguration":{"allOf":[{"$ref":"#/components/schemas/CarrierConfiguration"}],"description":"Configuration of Bring Carrier","properties":{"customerId":{"description":"Bring Carrier customer number.","type":"string"},"returnProduct":{"description":"Product that will be used for return","type":"string"},"shipmentProduct":{"description":"Product that will be used for the shipment booking","type":"string"},"supportPhoneNumber":{"description":"Bring Carrier support phone number.","type":"string"},"trackAndTraceUrl":{"type":"string"},"webhookFftHost":{"type":"string"}},"required":["customerId","supportPhoneNumber"],"title":"BringCarrierConfiguration"},"DpdChCarrierConfiguration":{"allOf":[{"$ref":"#/components/schemas/CarrierConfiguration"}],"description":"Configuration of DPD Switzerland Carrier","properties":{"trackAndTraceUrl":{"type":"string"}},"title":"DpdChCarrierConfiguration"},"DhlV2CarrierConfiguration":{"allOf":[{"$ref":"#/components/schemas/CarrierConfiguration"}],"description":"Configuration of DHL Carrier","properties":{"alwaysDoTrackAndTrace":{"default":false,"description":"If true, the track and trace will always be done, even if a parcel is directly created in DONE status","type":"boolean"},"sftpConfiguration":{"$ref":"#/components/schemas/DhlV2SftpConfiguration"},"shipperRef":{"description":"a shipperRef that can optionally be defined in the DHL business customer portal","type":"string"},"trackAndTraceUrl":{"type":"string"}},"title":"DhlV2CarrierConfiguration"},"DhlV2SftpConfiguration":{"additionalProperties":false,"properties":{"useSftpForTandT":{"default":false,"description":"Indicates if the SFTP should be used for tracking and tracing","type":"boolean"}},"required":["useSftpForTandT"],"title":"DhlV2SftpConfiguration","description":"DhlV2SftpConfiguration"},"VceCarrierConfiguration":{"allOf":[{"$ref":"#/components/schemas/CarrierConfiguration"}],"description":"Configuration of VCE Carrier","title":"VceCarrierConfiguration"},"PostNlCarrierConfiguration":{"allOf":[{"$ref":"#/components/schemas/CarrierConfiguration"}],"description":"Configuration of PostNL Carrier","properties":{"trackAndTraceUrl":{"type":"string"}},"title":"PostNlCarrierConfiguration"},"SevenSendersCarrierConfiguration":{"allOf":[{"$ref":"#/components/schemas/CarrierConfiguration"}],"description":"Configuration of Seven Senders Carrier","properties":{"trackAndTraceUrl":{"type":"string"},"warehouse":{"description":"The name of the warehouse that should be passed to Seven Senders, as configured in Seven Senders.","type":"string"}},"title":"SevenSendersCarrierConfiguration"},"UBSendCarrierConfiguration":{"allOf":[{"$ref":"#/components/schemas/CarrierConfiguration"}],"description":"Configuration of UBSend Carrier","title":"UBSendCarrierConfiguration"},"ApiError":{"items":{"$ref":"#/components/schemas/ErrorInner"},"type":"array","xml":{"name":"ApiError"},"title":"ApiError","description":"ApiError"},"ErrorInner":{"properties":{"description":{"type":"string"},"requestVersion":{"description":"The version provided within an invalid request.","format":"int64","type":"integer"},"summary":{"type":"string"},"version":{"format":"int64","type":"integer"}},"required":["summary"],"type":"object","title":"ErrorInner","description":"ErrorInner"}}},"paths":{"/api/carriers/{carrierId}/configuration":{"get":{"description":"","operationId":"getCarrierConfiguration","parameters":[{"description":"ID of the carrier you want to get the configuration","in":"path","name":"carrierId","required":true,"schema":{"type":"string"}}],"responses":{"200":{"content":{"application/json":{"schema":{"anyOf":[{"$ref":"#/components/schemas/CarrierConfiguration"},{"$ref":"#/components/schemas/GlsCarrierConfiguration"},{"$ref":"#/components/schemas/FedexCarrierConfiguration"},{"$ref":"#/components/schemas/BringCarrierConfiguration"},{"$ref":"#/components/schemas/DpdChCarrierConfiguration"},{"$ref":"#/components/schemas/DhlV2CarrierConfiguration"},{"$ref":"#/components/schemas/VceCarrierConfiguration"},{"$ref":"#/components/schemas/PostNlCarrierConfiguration"},{"$ref":"#/components/schemas/SevenSendersCarrierConfiguration"},{"$ref":"#/components/schemas/UBSendCarrierConfiguration"}]}}},"description":"Carrier Configuration was found & you were allowed to access it. The result is in the body."},"401":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"Your user is not allowed to operate against this API instance"},"403":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"Your user, although recognized, is not authorized to use this endpoint"},"404":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"Carrier Configuration not found"}},"summary":"Get carrier config","tags":["Carriers Configuration (Operations)"]}}}}
```

## PUT /api/carriers/{carrierId}/configuration

> Update carrier config

```json
{"openapi":"3.0.1","info":{"title":"fulfillmenttools","version":"VERSIONLESS"},"tags":[{"description":"Endpoints to create, update and read carriers configuration.","name":"Carriers Configuration (Operations)"}],"servers":[{"url":"https://{tenant}.api.fulfillmenttools.com","variables":{"tenant":{"default":"your-tenant-name"}}}],"security":[{"BearerToken":[]}],"components":{"securitySchemes":{"BearerToken":{"type":"http","scheme":"bearer","bearerFormat":"JWT"}},"schemas":{"CarrierConfiguration":{"allOf":[{"$ref":"#/components/schemas/VersionedResource"}],"description":"Configuration of a Carrier","properties":{"additionalWeightInPercent":{"description":"It is an amount of percentage for packaging weight which will be added to the calculated shipping weight","minimum":0,"type":"number"},"alternativeReturnAddress":{"$ref":"#/components/schemas/FacilityAddress"},"alternativeSendAddress":{"$ref":"#/components/schemas/FacilityAddress"},"carrierRef":{"type":"string"},"countryServiceMappings":{"items":{"$ref":"#/components/schemas/CarrierCountryServiceMapping"},"type":"array"},"defaultPickUpTime":{"$ref":"#/components/schemas/CarrierPickUpTime"},"fallBackTrackAndTraceEmail":{"description":"EmailAddress used to receive track and trace information when no other emailaddress was provided","format":"email","minLength":1,"type":"string"},"id":{"type":"string"},"mustBeWeighed":{"default":false,"description":"Indicates if the content of a parcel must be weighed before ordering a label","type":"boolean"},"nonDeliveryDaysPerCountryAndProvince":{"items":{"$ref":"#/components/schemas/NonDeliveryDaysPerCountryAndProvince"},"type":"array"},"returnLabel":{"default":false,"description":"When enabled, a return label will be created by creating a shipping label","type":"boolean"},"serviceUrl":{"type":"string"},"thresholdPriceValue":{"$ref":"#/components/schemas/ThresholdPriceValue"}},"required":["returnLabel","carrierRef"],"title":"CarrierConfiguration","type":"object"},"VersionedResource":{"properties":{"created":{"description":"The date this entity was created at the platform. This value is generated by the service.","format":"date-time","type":"string"},"lastModified":{"description":"The date this entity was modified last. This value is generated by the service.","format":"date-time","type":"string"},"version":{"description":"The version of the document to be used in optimistic locking mechanisms.","format":"int64","type":"integer"}},"required":["version"],"type":"object","title":"VersionedResource","description":"VersionedResource"},"FacilityAddress":{"allOf":[{"$ref":"#/components/schemas/FacilityAddressForCreation"},{"properties":{"resolvedTimeZone":{"$ref":"#/components/schemas/TimeZone"}},"type":"object"}],"type":"object","xml":{"name":"FacilityAddress"},"title":"FacilityAddress","description":"FacilityAddress"},"FacilityAddressForCreation":{"allOf":[{"$ref":"#/components/schemas/Address"},{"properties":{"companyName":{"type":"string"},"emailAddresses":{"items":{"properties":{"recipient":{"description":"Human readable information who is the recipient for emails sent to this address.","type":"string"},"value":{"type":"string"}},"required":["value"],"type":"object"},"type":"array"},"resolvedCoordinates":{"$ref":"#/components/schemas/Coordinates"},"resolvedTimeZone":{"$ref":"#/components/schemas/TimeZoneForCreation","description":"User-specified time zone in identifier format (e.g., \"America/Los_Angeles\"). Used to determine local time. Relevant only if the country spans multiple time zones; otherwise, the time zone is automatically determined from the country or via Google if unspecified."}},"required":["companyName"],"type":"object"}],"type":"object","xml":{"name":"FacilityAddressForCreation"},"title":"FacilityAddressForCreation","description":"FacilityAddressForCreation"},"Address":{"properties":{"additionalAddressInfo":{"type":"string"},"city":{"pattern":"^.+$","type":"string"},"country":{"description":"A two-digit country code as per ISO 3166-1 alpha-2","pattern":"^[A-Z]{2}$","type":"string"},"customAttributes":{"description":"Attributes that can be added to the address. These attributes cannot be used within fulfillment processes, but it could be useful to have the informations carried here.","type":"object"},"houseNumber":{"pattern":"^.+$","type":"string"},"phoneNumbers":{"items":{"properties":{"customAttributes":{"description":"Attributes that can be added to the phonenumber. These attributes cannot be used within fulfillment processes, but it could be useful to have the informations carried here.","type":"object"},"label":{"description":"Can be used to give a description for the number, like \"private\", \"business number\", etc.","type":"string"},"type":{"enum":["MOBILE","PHONE"],"type":"string"},"value":{"description":"The number itself. We do not enforce any format (yet).","type":"string"}},"required":["value","type"],"type":"object"},"type":"array"},"postalCode":{"pattern":"^.+$","type":"string"},"province":{"pattern":"^.+$","type":"string"},"street":{"pattern":"^.+$","type":"string"}},"required":["street","city","postalCode","country"],"type":"object","title":"Address","description":"Address"},"Coordinates":{"description":"Coordinates of the WGS84 geodetic reference system in Mercator projection, as used e.g. by the Google Maps API","properties":{"lat":{"description":"Latitude value","type":"number"},"lon":{"description":"Longitude value","type":"number"}},"required":["lat","lon"],"type":"object","title":"Coordinates"},"TimeZoneForCreation":{"description":"Self-provided timezone for determining the local time of a facility","properties":{"timeZoneId":{"description":"official id of the timezone","type":"string"}},"required":["timeZoneId"],"type":"object","title":"TimeZoneForCreation"},"TimeZone":{"description":"Timezone for information retrieved e.g. by the Google Maps API","properties":{"offsetInSeconds":{"description":"offset in seconds to standard time. Does not account for daylight saving time.","type":"number"},"source":{"description":"source of the timezone information","type":"string"},"timeZoneId":{"description":"official id of the timezone","type":"string"},"timeZoneName":{"description":"descriptive name of the timezone","type":"string"}},"required":["timeZoneId","timeZoneName","offsetInSeconds"],"type":"object","title":"TimeZone"},"CarrierCountryServiceMapping":{"additionalProperties":false,"properties":{"additionalShippingArticleAttributes":{"description":"Article Attributes that will be displayed in the client as additional. They are not mandatory but could benefit the process. Mandatory fields can not be additional. If duplicates found, the additional values will be removed on read.","items":{"$ref":"#/components/schemas/AdditionalShippingArticleAttribute"},"minItems":0,"type":"array"},"additionalShippingAttributes":{"description":"Shipping Attributes that will be displayed in the client as additional. They are not mandatory but could benefit the process. Mandatory fields can not be additional If duplicates found, the additional values will be removed on read.","items":{"$ref":"#/components/schemas/AdditionalShippingAttribute"},"minItems":0,"type":"array"},"carrierProductCategory":{"$ref":"#/components/schemas/CarrierProductCategory"},"carrierServices":{"description":"Services which can be provided by the carrier","items":{"$ref":"#/components/schemas/CarrierServices"},"type":"array"},"countAsTransitDayBefore":{"type":"string"},"deliveryCosts":{"items":{"$ref":"#/components/schemas/DeliveryCost"},"maxItems":1,"type":"array"},"destinationCountries":{"description":"This part of the API is deprecated. For details please check the <a href=\"https://docs.fulfillmenttools.com/documentation/developer-docs/api/core-concepts/api-release-life-cycle#deprecated\" target=\"_blank\">api-release-life-cycle documentation</a>.<br /><br />@deprecated - Use destination instead.","items":{"$ref":"#/components/schemas/CountryCode"},"minItems":1,"type":"array","deprecated":true},"destinations":{"description":"The destination regions this mapping should be applied to.","items":{"$ref":"#/components/schemas/RegionInformation"},"minItems":1,"type":"array"},"id":{"description":"unique identifier for a countryServiceMapping","type":"string"},"mandatoryShippingArticleAttributes":{"items":{"$ref":"#/components/schemas/MandatoryShippingArticleAttribute"},"minItems":0,"type":"array"},"mandatoryShippingAttributes":{"items":{"$ref":"#/components/schemas/MandatoryShippingAttribute"},"minItems":0,"type":"array"},"mandatoryShippingItemAttributes":{"deprecated":true,"description":"Deprecated - use mandatoryShippingArticleAttributes instead","items":{"$ref":"#/components/schemas/MandatoryShippingItemAttribute"},"minItems":0,"type":"array"},"products":{"description":"Array of products for the given mapping","items":{"type":"string"},"type":"array"},"source":{"$ref":"#/components/schemas/RegionInformation"},"sourceCountry":{"description":"This part of the API is deprecated. For details please check the <a href=\"https://docs.fulfillmenttools.com/documentation/developer-docs/api/core-concepts/api-release-life-cycle#deprecated\" target=\"_blank\">api-release-life-cycle documentation</a>.<br /><br />@deprecated - Use source instead.","maxLength":2,"minLength":2,"type":"string","deprecated":true},"staticCCSMRef":{"type":"string"},"transitTime":{"$ref":"#/components/schemas/CarrierTransitTime"}},"required":["id","source","destinations"],"type":"object","title":"CarrierCountryServiceMapping","description":"CarrierCountryServiceMapping"},"AdditionalShippingArticleAttribute":{"allOf":[{"$ref":"#/components/schemas/CountryServiceMappingShippingArticleAttribute"}],"title":"AdditionalShippingArticleAttribute","description":"AdditionalShippingArticleAttribute"},"CountryServiceMappingShippingArticleAttribute":{"additionalProperties":false,"properties":{"descriptionLocalized":{"$ref":"#/components/schemas/LocaleString"},"category":{"$ref":"#/components/schemas/MandatoryShippingArticleAttributeCategory"},"dataType":{"$ref":"#/components/schemas/MandatoryShippingArticleAttributeDataType"},"description":{"type":"string"},"referencedField":{"$ref":"#/components/schemas/MandatoryShippingArticleAttributeReferencedField"}},"required":["referencedField","dataType","category","descriptionLocalized"],"type":"object","title":"CountryServiceMappingShippingArticleAttribute","description":"CountryServiceMappingShippingArticleAttribute"},"LocaleString":{"additionalProperties":{"type":"string"},"description":"Provides Localized values. The key is the locale, the value is the translation. https://docs.fulfillmenttools.com/documentation/developer-docs/api/core-concepts/localization","title":"LocaleString","type":"object"},"MandatoryShippingArticleAttributeCategory":{"enum":["customs","dimensions","insurance"],"type":"string","title":"MandatoryShippingArticleAttributeCategory","description":"MandatoryShippingArticleAttributeCategory"},"MandatoryShippingArticleAttributeDataType":{"enum":["NUMBER","STRING"],"type":"string","title":"MandatoryShippingArticleAttributeDataType","description":"MandatoryShippingArticleAttributeDataType"},"MandatoryShippingArticleAttributeReferencedField":{"enum":["attributes.weightPerUnit","attributes.hsCode","attributes.currency","attributes.valuePerUnit","attributes.countryOfManufacture"],"type":"string","title":"MandatoryShippingArticleAttributeReferencedField","description":"MandatoryShippingArticleAttributeReferencedField"},"AdditionalShippingAttribute":{"allOf":[{"$ref":"#/components/schemas/CountryServiceMappingShippingAttribute"}],"title":"AdditionalShippingAttribute","description":"AdditionalShippingAttribute"},"CountryServiceMappingShippingAttribute":{"additionalProperties":false,"properties":{"descriptionLocalized":{"$ref":"#/components/schemas/LocaleString"},"dataType":{"enum":["Number","String","Date","Boolean"],"type":"string"},"description":{"type":"string"},"referencedField":{"description":"- dimensions.weight: will be calculated from MandatoryShippingArticleAttribute.attributes.weightPerUnit if items with weightPerUnit is set on all items - productValue: will be calculated from MandatoryShippingArticleAttribute.attributes.pricePerUnit if items with pricePerUnit is set on all items","enum":["dimensions.weight","productValue","pickUpInformation.startTime","pickUpInformation.endTime","services.BulkyGoods","services.Signature","services.AdultSignature","services.CustomerSignature","services.SaturdayDelivery","services.IdentityCheckPrivate","services.IdentityCheckCompany","services.AdditionalTransportInsurance","carrierInformation.shippingContainerNumber"],"type":"string"}},"type":"object","title":"CountryServiceMappingShippingAttribute","description":"CountryServiceMappingShippingAttribute"},"CarrierProductCategory":{"description":"Desired product class to choose when ordering a label, this is not a carrier specific value","enum":["STANDARD","EXPRESS","VALUE","FORWARDING"],"type":"string","title":"CarrierProductCategory"},"CarrierServices":{"description":"Services which should be booked from carrier","enum":["SIGNATURE","CUSTOMER_SIGNATURE","ADULT_SIGNATURE","SATURDAY_DELIVERY","IDENTITY_CHECK_COMPANY","IDENTITY_CHECK_PRIVATE","ADDITIONAL_TRANSPORTATION_INSURANCE"],"type":"string","title":"CarrierServices"},"DeliveryCost":{"additionalProperties":false,"properties":{"cost":{"description":"The cost of sending with a carrier","type":"number"},"currency":{"description":"currency as 3 letter iso code","pattern":"^[A-Z]{3}$","type":"string"}},"required":["cost","currency"],"type":"object","title":"DeliveryCost","description":"DeliveryCost"},"CountryCode":{"description":"ISO 3166 ALPHA-2 of country","maxLength":2,"minLength":2,"type":"string","title":"CountryCode"},"RegionInformation":{"properties":{"countryCode":{"$ref":"#/components/schemas/CountryCode"},"postalCodes":{"items":{"type":"string"},"type":"array"}},"required":["countryCode"],"type":"object","title":"RegionInformation","description":"RegionInformation"},"MandatoryShippingArticleAttribute":{"allOf":[{"$ref":"#/components/schemas/CountryServiceMappingShippingArticleAttribute"}],"title":"MandatoryShippingArticleAttribute","description":"MandatoryShippingArticleAttribute"},"MandatoryShippingAttribute":{"allOf":[{"$ref":"#/components/schemas/CountryServiceMappingShippingAttribute"}],"title":"MandatoryShippingAttribute","description":"MandatoryShippingAttribute"},"MandatoryShippingItemAttribute":{"additionalProperties":false,"properties":{"descriptionLocalized":{"$ref":"#/components/schemas/LocaleString"},"dataType":{"enum":["Number","String","Date","Boolean"],"type":"string"},"description":{"type":"string"},"referencedField":{"description":"Deprecated:\n  - description: article.title will be used instead\n  - weightInGram: use MandatoryShippingArticleAttribute.attributes.weightPerUnit\n  - quantity, this field is now mandatory in the item\n  - parcelItemValue.value: use MandatoryShippingArticleAttribute.attributes.pricePerUnit\n  - parcelItemValue.currency: use MandatoryShippingArticleAttribute.attributes.currency\n  - countryOfManufacture: use MandatoryShippingArticleAttribute.attributes.countryOfManufacture\n  - tenantArticleId: mandatory on line item article","enum":["description","weightInGram","quantity","parcelItemValue.value","parcelItemValue.currency","countryOfManufacture","tenantArticleId"],"type":"string"}},"type":"object","title":"MandatoryShippingItemAttribute","description":"MandatoryShippingItemAttribute"},"CarrierTransitTime":{"properties":{"maxTransitDays":{"description":"Maximum days a carrier needs for transit","minimum":0,"type":"integer"},"minTransitDays":{"description":"Minimum days a carrier needs for transit","minimum":0,"type":"integer"}},"required":["maxTransitDays","minTransitDays"],"type":"object","title":"CarrierTransitTime","description":"CarrierTransitTime"},"CarrierPickUpTime":{"additionalProperties":false,"description":"Default pick up time configuration for carriers supporting pick up scheduling, will be used to calculate the next possible pick up date","properties":{"end":{"$ref":"#/components/schemas/TimeStamp"},"start":{"$ref":"#/components/schemas/TimeStamp"}},"required":["start","end"],"title":"CarrierPickUpTime"},"TimeStamp":{"properties":{"hour":{"maximum":23,"minimum":0,"type":"number"},"minute":{"maximum":59,"minimum":0,"type":"number"}},"required":["hour","minute"],"type":"object","title":"TimeStamp","description":"TimeStamp"},"NonDeliveryDaysPerCountryAndProvince":{"additionalProperties":false,"properties":{"country":{"type":"string"},"nonDeliveryDays":{"items":{"$ref":"#/components/schemas/NonDeliveryDays"},"type":"array"},"nonDeliveryDaysPerProvince":{"items":{"$ref":"#/components/schemas/NonDeliveryDaysPerProvince"},"type":"array"},"recurringNonDeliveryWeekdays":{"items":{"$ref":"#/components/schemas/WeekDay"},"type":"array"}},"required":["country","nonDeliveryDays","recurringNonDeliveryWeekdays","nonDeliveryDaysPerProvince"],"type":"object","title":"NonDeliveryDaysPerCountryAndProvince","description":"NonDeliveryDaysPerCountryAndProvince"},"NonDeliveryDays":{"additionalProperties":false,"properties":{"nonDeliveryDay":{"format":"date","pattern":"^\\d{4}-\\d{2}-\\d{2}$","type":"string"},"nonDeliveryType":{"$ref":"#/components/schemas/NonDeliveryType","default":"SINGLE"}},"required":["nonDeliveryDay"],"type":"object","title":"NonDeliveryDays","description":"NonDeliveryDays"},"NonDeliveryType":{"enum":["SINGLE","RECURRING"],"type":"string","title":"NonDeliveryType","description":"NonDeliveryType"},"NonDeliveryDaysPerProvince":{"additionalProperties":false,"properties":{"nonDeliveryDays":{"items":{"$ref":"#/components/schemas/NonDeliveryDays"},"type":"array"},"province":{"type":"string"},"recurringNonDeliveryWeekdays":{"items":{"$ref":"#/components/schemas/WeekDay"},"type":"array"}},"required":["province","nonDeliveryDays","recurringNonDeliveryWeekdays"],"type":"object","title":"NonDeliveryDaysPerProvince","description":"NonDeliveryDaysPerProvince"},"WeekDay":{"description":"A weekday","enum":["MONDAY","TUESDAY","WEDNESDAY","THURSDAY","FRIDAY","SATURDAY","SUNDAY"],"type":"string","xml":{"name":"WeekDay"},"title":"WeekDay"},"ThresholdPriceValue":{"additionalProperties":false,"properties":{"priceRange":{"$ref":"#/components/schemas/PriceRange"},"priority":{"description":"The lower the value the higher is the priority, e.g. priority 1 is higher than priority 10. The priority is used when comparing multiple carriers.","minimum":1,"type":"integer"}},"required":["priority","priceRange"],"type":"object","title":"ThresholdPriceValue","description":"ThresholdPriceValue"},"PriceRange":{"additionalProperties":false,"properties":{"currency":{"allOf":[{"$ref":"#/components/schemas/CurrencyCode"}],"description":"The currency of the price as an ISO 4217 code.","nullable":true,"type":"string"},"decimalPlaces":{"description":"Number of decimal places for the given currency","minimum":0,"type":"integer"},"from":{"description":"Lowest total parcel value that this carrier will be selected for. Value is in configured in the smallest subunit, e.g. cents.","minimum":0,"type":"integer"},"to":{"description":"Highest total parcel value that this carrier will be selected for. Value is configured in the smallest subunit, e.g. cents.","minimum":1,"type":"integer"}},"required":["from","to","currency","decimalPlaces"],"type":"object","title":"PriceRange","description":"PriceRange"},"CurrencyCode":{"description":"The currency code is a three-letter code that represents a currency in the ISO 4217 standard.","enum":["AED","AFN","ALL","AMD","ANG","AOA","ARS","AUD","AWG","AZN","BAM","BBD","BDT","BGN","BHD","BIF","BMD","BND","BOB","BOV","BRL","BSD","BTN","BWP","BYN","BZD","CAD","CDF","CHE","CHF","CHW","CLF","CLP","CNY","COP","COU","CRC","CUC","CUP","CVE","CZK","DJF","DKK","DOP","DZD","EGP","ERN","ETB","EUR","FJD","FKP","GBP","GEL","GHS","GIP","GMD","GNF","GTQ","GYD","HKD","HNL","HTG","HUF","IDR","ILS","INR","IQD","IRR","ISK","JMD","JOD","JPY","KES","KGS","KHR","KMF","KPW","KRW","KWD","KYD","KZT","LAK","LBP","LKR","LRD","LSL","LYD","MAD","MDL","MGA","MKD","MMK","MNT","MOP","MRU","MUR","MVR","MWK","MXN","MXV","MYR","MZN","NAD","NGN","NIO","NOK","NPR","NZD","OMR","PAB","PEN","PGK","PHP","PKR","PLN","PYG","QAR","RON","RSD","RUB","RWF","SAR","SBD","SCR","SDG","SEK","SGD","SHP","SLE","SOS","SRD","SSP","STN","SVC","SYP","SZL","THB","TJS","TMT","TND","TOP","TRY","TTD","TWD","TZS","UAH","UGX","USD","USN","UYI","UYU","UYW","UZS","VED","VES","VND","VUV","WST","XAF","XAG","XAU","XBA","XBB","XBC","XBD","XCD","XDR","XOF","XPD","XPF","XPT","XSU","XTS","XUA","XXX","YER","ZAR","ZMW","ZWL"],"type":"string","title":"CurrencyCode"},"GlsCarrierConfiguration":{"allOf":[{"$ref":"#/components/schemas/CarrierConfiguration"}],"description":"Configuration of GLS Carrier","properties":{"alternativeReturnAddressLocationId":{"minLength":1,"type":"string"},"alternativeSendAddressLocationId":{"minLength":1,"type":"string"},"trackAndTraceUrl":{"type":"string"},"trackAndTraceWsdlUrl":{"type":"string"}},"title":"GlsCarrierConfiguration"},"FedexCarrierConfiguration":{"allOf":[{"$ref":"#/components/schemas/CarrierConfiguration"}],"description":"Configuration of Fedex Carrier","properties":{"defaultCommodityDescription":{"description":"Describes the shipped goods","type":"string"},"defaultManufactureCountry":{"description":"A two-digit country code as per ISO 3166-1 alpha-2","pattern":"^[A-Z]{2}$","type":"string"},"defaultPriceCurrency":{"description":"default currency of shipped goods as 3 letter iso code","pattern":"^[A-Z]{3}$","type":"string"},"defaultPriceValue":{"description":"Default value of shipped goods","type":"number"},"trackAndTraceUrl":{"type":"string"},"useEconomyService":{"description":"Indicates if the economy services of fedex should be used.","type":"boolean"}},"required":["useEconomyService","defaultPriceCurrency","defaultPriceValue","defaultManufactureCountry","defaultCommodityDescription"],"title":"FedexCarrierConfiguration"},"BringCarrierConfiguration":{"allOf":[{"$ref":"#/components/schemas/CarrierConfiguration"}],"description":"Configuration of Bring Carrier","properties":{"customerId":{"description":"Bring Carrier customer number.","type":"string"},"returnProduct":{"description":"Product that will be used for return","type":"string"},"shipmentProduct":{"description":"Product that will be used for the shipment booking","type":"string"},"supportPhoneNumber":{"description":"Bring Carrier support phone number.","type":"string"},"trackAndTraceUrl":{"type":"string"},"webhookFftHost":{"type":"string"}},"required":["customerId","supportPhoneNumber"],"title":"BringCarrierConfiguration"},"DpdChCarrierConfiguration":{"allOf":[{"$ref":"#/components/schemas/CarrierConfiguration"}],"description":"Configuration of DPD Switzerland Carrier","properties":{"trackAndTraceUrl":{"type":"string"}},"title":"DpdChCarrierConfiguration"},"DhlV2CarrierConfiguration":{"allOf":[{"$ref":"#/components/schemas/CarrierConfiguration"}],"description":"Configuration of DHL Carrier","properties":{"alwaysDoTrackAndTrace":{"default":false,"description":"If true, the track and trace will always be done, even if a parcel is directly created in DONE status","type":"boolean"},"sftpConfiguration":{"$ref":"#/components/schemas/DhlV2SftpConfiguration"},"shipperRef":{"description":"a shipperRef that can optionally be defined in the DHL business customer portal","type":"string"},"trackAndTraceUrl":{"type":"string"}},"title":"DhlV2CarrierConfiguration"},"DhlV2SftpConfiguration":{"additionalProperties":false,"properties":{"useSftpForTandT":{"default":false,"description":"Indicates if the SFTP should be used for tracking and tracing","type":"boolean"}},"required":["useSftpForTandT"],"title":"DhlV2SftpConfiguration","description":"DhlV2SftpConfiguration"},"VceCarrierConfiguration":{"allOf":[{"$ref":"#/components/schemas/CarrierConfiguration"}],"description":"Configuration of VCE Carrier","title":"VceCarrierConfiguration"},"PostNlCarrierConfiguration":{"allOf":[{"$ref":"#/components/schemas/CarrierConfiguration"}],"description":"Configuration of PostNL Carrier","properties":{"trackAndTraceUrl":{"type":"string"}},"title":"PostNlCarrierConfiguration"},"SevenSendersCarrierConfiguration":{"allOf":[{"$ref":"#/components/schemas/CarrierConfiguration"}],"description":"Configuration of Seven Senders Carrier","properties":{"trackAndTraceUrl":{"type":"string"},"warehouse":{"description":"The name of the warehouse that should be passed to Seven Senders, as configured in Seven Senders.","type":"string"}},"title":"SevenSendersCarrierConfiguration"},"UBSendCarrierConfiguration":{"allOf":[{"$ref":"#/components/schemas/CarrierConfiguration"}],"description":"Configuration of UBSend Carrier","title":"UBSendCarrierConfiguration"},"ApiError":{"items":{"$ref":"#/components/schemas/ErrorInner"},"type":"array","xml":{"name":"ApiError"},"title":"ApiError","description":"ApiError"},"ErrorInner":{"properties":{"description":{"type":"string"},"requestVersion":{"description":"The version provided within an invalid request.","format":"int64","type":"integer"},"summary":{"type":"string"},"version":{"format":"int64","type":"integer"}},"required":["summary"],"type":"object","title":"ErrorInner","description":"ErrorInner"}}},"paths":{"/api/carriers/{carrierId}/configuration":{"put":{"description":"","operationId":"putCarrierConfiguration","parameters":[{"description":"ID of the carrier you want to update the configuration","in":"path","name":"carrierId","required":true,"schema":{"type":"string"}}],"requestBody":{"content":{"application/json":{"schema":{"anyOf":[{"$ref":"#/components/schemas/CarrierConfiguration"},{"$ref":"#/components/schemas/GlsCarrierConfiguration"},{"$ref":"#/components/schemas/FedexCarrierConfiguration"},{"$ref":"#/components/schemas/BringCarrierConfiguration"},{"$ref":"#/components/schemas/DpdChCarrierConfiguration"},{"$ref":"#/components/schemas/DhlV2CarrierConfiguration"},{"$ref":"#/components/schemas/VceCarrierConfiguration"},{"$ref":"#/components/schemas/PostNlCarrierConfiguration"},{"$ref":"#/components/schemas/SevenSendersCarrierConfiguration"},{"$ref":"#/components/schemas/UBSendCarrierConfiguration"}]}}},"description":"Carrier Configuration","required":true},"responses":{"200":{"content":{"application/json":{"schema":{"anyOf":[{"$ref":"#/components/schemas/CarrierConfiguration"},{"$ref":"#/components/schemas/GlsCarrierConfiguration"},{"$ref":"#/components/schemas/FedexCarrierConfiguration"},{"$ref":"#/components/schemas/BringCarrierConfiguration"},{"$ref":"#/components/schemas/DpdChCarrierConfiguration"},{"$ref":"#/components/schemas/DhlV2CarrierConfiguration"},{"$ref":"#/components/schemas/VceCarrierConfiguration"},{"$ref":"#/components/schemas/PostNlCarrierConfiguration"},{"$ref":"#/components/schemas/SevenSendersCarrierConfiguration"},{"$ref":"#/components/schemas/UBSendCarrierConfiguration"}]}}},"description":"Carrier Configuration was found & you were allowed to access it. The result is in the body."},"401":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"Your user is not allowed to operate against this API instance"},"403":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"Your user, although recognized, is not authorized to use this endpoint"},"404":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"Carrier Configuration not found"}},"summary":"Update carrier config","tags":["Carriers Configuration (Operations)"]}}}}
```
